Index: trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 633)
+++ trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 635)
@@ -1,6 +1,5 @@
 c**********************************************************************
 
-      subroutine jthermcalc
-     $ (co2x,o2x,o3px,h2x,h2ox,h2o2x,aux1,aux2,tx,nz,iz,date,zenit)
+      subroutine jthermcalc(ig,chemthermod,rm,nesptherm,tx,iz,zenit)
 
 
@@ -15,45 +14,46 @@
 
 c     common variables and constants
-
+      include "dimensions.h"
+      include "dimphys.h"
       include 'param.h'
-      include 'param_v3.h'
+      include 'param_v4.h'
+
+c     input and output variables
+
+      integer    ig
+      integer    chemthermod
+      integer    nesptherm                      !Number of species considered
+      real       rm(nlayermx,nesptherm)         !Densities (cm-3)
+      real       tx(nlayermx)                   !temperature
+      real       zenit                          !SZA
+      real       iz(nlayermx)                   !Local altitude
+
 
 c    local parameters and variables
 
-      real       xabsi(nabs,nzmax) !densities
-      real       nada
-      real       co2colx2(nzmax,ninter)
-      real       o2colx2(nzmax,ninter)
-      real       o3pcolx2(nzmax,ninter)
-      real       co2colx(nzmax)              !column density of CO2 (cm^-2)
-      real       o2colx(nzmax)               !column density of O2(cm^-2)
-      real       o3pcolx(nzmax)              !column density of O(3P)(cm^-2)
-      real       h2o2colx(nzmax)             !column density of H2O2(cm^-2)
-      real       t2(nzmax)
-      real       coltemp(nzmax)
-      real       dt(nzmax)
-      real       sigma(ninter,nzmax)
-      real       alfa(ninter,nzmax)
-      real       xx
-      real       grav(nzmax)
+      real       aux1(nlayermx)	                !auxiliar variable
+      real       aux2(nlayermx)                 !auxiliar variable
+      real       co2colx(nlayermx)              !column density of CO2 (cm^-2)
+      real       o2colx(nlayermx)               !column density of O2(cm^-2)
+      real       o3pcolx(nlayermx)              !column density of O(3P)(cm^-2)
+      real       h2colx(nlayermx)               !H2 column density (cm-2)
+      real       h2ocolx(nlayermx)              !H2O column density (cm-2)
+      real       h2o2colx(nlayermx)             !column density of H2O2(cm^-2)
+      real       o3colx(nlayermx)               !O3 column density (cm-2)
+      real       n2colx(nlayermx)               !N2 column density (cm-2)
+      real       ncolx(nlayermx)                !N column density (cm-2)
+      real       nocolx(nlayermx)               !NO column density (cm-2)
+      real       cocolx(nlayermx)               !CO column density (cm-2)
+      real       hcolx(nlayermx)                !H column density (cm-2)
+      real       no2colx(nlayermx)              !NO2 column density (cm-2)
+      real       t2(nlayermx)
+      real       coltemp(nlayermx)
+      real       sigma(ninter,nlayermx)
+      real       alfa(ninter,nlayermx)
       
-      integer    i,j,k,icol,indexint          !indexes
+      integer    i,j,k,indexint                 !indexes
       character  dn
 
-c     input and output variables
-
-      integer    nz                          !number of layers
-      real       co2x(nz)                    !density of CO2(cm^-3)
-      real       o2x(nz)                     !density of O2(cm^-3)
-      real       o3px(nz)                    !density of O(3P)(cm^-3)
-      real       h2x(nz)                     !density of H2(cm^-3)
-      real       h2ox(nz)                    !density of H2O(cm^-3)
-      real       h2o2x(nz)                   !density of H2O2(cm^-3)
-      real       aux1(nz)	             !auxiliar variable
-      real       aux2(nz)                    !auxiliar variable
-      real       tx(nz)                      !temperature
-      real       date
-      real       zenit
-      real       iz(nz)
+
 
 
@@ -65,7 +65,11 @@
       real       limup                        !        ""
 
+      !!!ATTENTION. Here i_co2 has to have the same value than in chemthermos.F90
+      !!!If the value is changed there, if has to be changed also here !!!!
+      integer,parameter :: i_co2=1
+
 c*************************PROGRAM STARTS*******************************
-
-      if(zenit.gt.100.) then
+      
+      if(zenit.gt.140.) then
          dn='n'
          else
@@ -74,81 +78,87 @@
       if(dn.eq.'n') then
         return
-      endif 
-     
-      do i=1,nz
-         xabsi(1,i) = co2x(i)
-         xabsi(2,i) = o2x(i)
-         xabsi(3,i) = o3px(i)
-         xabsi(4,i) = h2ox(i)
-         xabsi(5,i) = h2x(i)
-         xabsi(6,i) = h2o2x(i)
-      end do
-
-      do i=1,nz
+      endif
+      
+      !Initializing the photoabsorption coefficients
+      jfotsout(:,:,:)=0.
+
+      !Auxiliar temperature to take into account the temperature dependence
+      !of CO2 cross section
+      do i=1,nlayermx
          t2(i)=tx(i)
-         if(t0(i).lt.195.0) t0(i)=195.0
-         if(t0(i).gt.295.0) t0(i)=295.0
          if(t2(i).lt.195.0) t2(i)=195.0
          if(t2(i).gt.295.0) t2(i)=295.0
       end do
 
-
-c    COLUMN CALCULATION 
-
-      call column(co2x,o2x,o3px,h2x,h2ox,h2o2x,tx,nz,iz,zenit,co2colx
-     $,o2colx,o3pcolx,h2o2colx)
-
-      coltemp(nz)=co2colx(nz)*abs(t2(nz)-t0(nz))
-      dt(nz)=coltemp(nz)/co2colx(nz)
-      do i=nz-1,1,-1
-        coltemp(i)=coltemp(i+1)+ 
-     $         ( co2x(i) + co2x(i+1) ) * 0.5 
+      !Calculation of column amounts 
+      call column(ig,chemthermod,rm,nesptherm,tx,iz,zenit,
+     $     co2colx,o2colx,o3pcolx,h2colx,h2ocolx,
+     $     h2o2colx,o3colx,n2colx,ncolx,nocolx,cocolx,hcolx,no2colx)
+
+      !Auxiliar column to include the temperature dependence 
+      !of CO2 cross section
+      coltemp(nlayermx)=co2colx(nlayermx)*abs(t2(nlayermx)-t0(nlayermx))
+      do i=nlayermx-1,1,-1
+        coltemp(i)=!coltemp(i+1)+     PQ SE ELIMINA? REVISAR 
+     $         ( rm(i,i_co2) + rm(i+1,i_co2) ) * 0.5 
      $         * 1e5 * (iz(i+1)-iz(i)) * abs(t2(i)-t0(i))
-        dt(i)=coltemp(i)/co2colx(i)
-      end do
-
-
-c     Calculo la seccion eficaz de CO2 a la temperatura t0 a cada altura
-c CALCULATION OF CO2 CROSS-SECTION AT TEMPERATURE T0 AT EACH HEIGHT
-
-      do i=1,nz
+      end do
+      
+      !Calculation of CO2 cross section at temperature t0(i)
+      do i=1,nlayermx
          do indexint=24,32
-           sigma(indexint,i)=co2crsc195(indexint-23)*
-     $         (1+((co2crsc295(indexint-23)/co2crsc195(indexint-23))-1.)
-     $         *(t0(i)-195.)/100.)
-           if(t0(i).ne.295.) then
-             alfa(indexint,i)=((co2crsc295(indexint-23)
-     $                        /sigma(indexint,i))-1.)/(295.-t0(i))
-           else 
-             alfa(indexint,i)=0.
-           end if
-         end do
-      end do
-
-
-c     Comienza la interpolacion
-c INTERPOLATION BEGINS
+           sigma(indexint,i)=co2crsc195(indexint-23)
+           alfa(indexint,i)=((co2crsc295(indexint-23)
+     $          /sigma(indexint,i))-1.)/(295.-t0(i))
+        end do
+      end do
+
+! Interpolation to the tabulated photoabsorption coefficients for each species
+! in each spectral interval
+
+!AQUI SE PODRIAN AGRUPAR CALCULOS PARA AHORRAR TIEMPO DE CPU
+!P.EJ. LOS CALCULOS DE AUX2 y AUX4 NO ES NECESARIO REPETIRLOS
+!PARA CADA ESPECIE EN UN INTERVALO.
+!REVISAR
+
+!TAMBIEN SE PODRIA PONER, EN LUGAR DE CONDICIONES SOBRE CHEMTHERMOD
+!PARA VER QUE ESPECIES SE CONSIDERAN, PONER CONDICION SOBRE LA EXISTENCIA DE 
+!CADA ESPECIE EN TRACEUR.DEF. ASI SE CALCULARIA LA FOTOABSORCION DE TODAS LAS
+!ESPECIES INCLUIDAS, AUNQUE LUEGO NO SE TENGA EN CUENTA EN LA QUIMICA (P.EJ.,
+!SI HAY NO2 PERO NO NO, NO SE CALCULARIA QUIMICA DEL NITROGENO PERO SE PODRIA
+!TENER EN CUENTA PARA EL CALENTAMIENTO
+!ESTUDIAR EN EL FUTURO
+
+!OTRA POSIBILIDAD ES SUSTITUIR LA ESCRITURA EN DURO DE LOS INDICES
+!DE LAS ESPECIES EN JABSIFOTS, CRSCABSI, ETC. POR INDICES DEL TIPO I_*
+!ESTUDIAR EN EL FUTURO
 c************************************************
-c     o2,0.1,5.0
+c     co2,0.1,6.0
 c************************************************
-      
+
       indexint=1
       limdown=1e-20
       limup=1e26
-       do i=1,nz
-         aux2(nz-i+1) = o2colx(i) + o3pcolx(i)
-       end do
-       do i=1,nz2
-         aux3(i) = jabsifotsint(indexint,2,nz2-i+1)
-         aux4(i) = c23(nz2-i+1)
-       enddo
-       call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup)
-       do i=1,nz
-         jfotsout(indexint,2,i) = aux1(nz-i+1)
-       enddo
+      do i=1,nlayermx
+         aux1(i)=0.
+         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint) +
+     $        o2colx(i)*crscabsi2(2,indexint) + 
+     $        o3pcolx(i)*crscabsi2(3,indexint) + 
+     $        h2colx(i)*crscabsi2(5,indexint) + 
+     $        ncolx(i)*crscabsi2(9,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
+      enddo
 
 c************************************************
-c     o3p,0.1,5.0
+c     o2,0.1,6.0
 c************************************************
 
